/*!
 * Copyright (c) 2018, 2019 Adrian Siekierka
 *
 * This file is part of Zeta.
 *
 * Zeta is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Zeta is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Zeta.  If not, see <http://www.gnu.org/licenses/>.
 */
var ZetaVfs={};ZetaVfs.fromMap=function(inMap,options){var map={};for(var key in inMap)map[key.toUpperCase()]=inMap[key];var readOnly=options&&options.readonly||!1;return{readonly:function(){return readOnly},contains:function(key){return map.hasOwnProperty(key.toUpperCase())},get:function(key){return map.hasOwnProperty(key.toUpperCase())?map[key.toUpperCase()].slice(0):null},list:function(filter){var a=[];for(var key in map)(null==filter||filter(key))&&a.push(key);return a},set:function(key,value){return!readOnly&&(map[key.toUpperCase()]=value,!0)}}},ZetaVfs.fromZip=function(url,filenameFilter,progressCallback,finishCallback){var xhr=new XMLHttpRequest;xhr.open("GET",url,!0),xhr.responseType="arraybuffer",xhr.onprogress=function(event){progressCallback(event.loaded/event.total)},xhr.onload=function(){console.log(this.response),progressCallback(1);var files=UZIP.parse(this.response),fileMap={};for(var key in files)(null==filenameFilter||filenameFilter(key))&&(fileMap[key]=files[key]);finishCallback(ZetaVfs.fromMap(fileMap))},xhr.send()},ZetaVfs.fromProviders=function(providers){return{readonly:function(){for(var p=0;p<providers.length;p++)if(providers[p].readonly())return!0;return!1},contains:function(key){for(var p=0;p<providers.length;p++)if(providers[p].contains(key))return!0;return!1},get:function(key){for(var p=providers.length-1;p>=0;p--)if(providers[p].contains(key))return providers[p].get(key);return null},list:function(filter){for(var data=[],p=0;p<providers.length;p++)data=data.concat(providers[p].list(filter));return data.sort()},set:function(key,value){for(var p=providers.length-1;p>=0;p--)if(providers[p].set(key,value))return!0;return!1}}};
ZetaRender={},ZetaRender.toCanvas=function(canvas,options){var blink_duration=options&&options.blink_duration||466,ctx=canvas.getContext("2d",{alpha:!1});ctx.imageSmoothingEnabled=!1;var video_blink=!0;options&&options.hasOwnProperty("blink")&&(video_blink=options.blink);var drawChrWidth,chrWidth,scrWidth,chrHeight,scrHeight,pw,ph,cw,ch,video_mode=-1,chrBuf=[],scale=1,asciiFg=null,charset=null,palette=null,rdDirty=!1,charset_override_enabled=options&&options.charset_override||!1,charset_override=null;if(charset_override_enabled){var coImg=new Image;coImg.src=options.charset_override,coImg.onload=function(){charset_override=coImg,rdDirty=!0}}var updVideoMode=function(val){val!=video_mode&&(chrBuf=[],scrWidth=2==(2&val)?80:40,scrHeight=25,video_mode=val),drawChrWidth=chrWidth*(80/scrWidth),pw=scrWidth*drawChrWidth,ph=scrHeight*chrHeight,cw=canvas.width,ch=canvas.height,scale=Math.min(Math.floor(cw/pw),Math.floor(ch/ph))},drawChar=function(x,y,chr,col,time){video_blink&&col>=128&&(col&=127,time%blink_duration>=blink_duration/2&&(col=17*(col>>4)));var buffered=chrBuf[80*y+x],bufcmp=chr<<8|col;if(buffered!=bufcmp){chrBuf[80*y+x]=bufcmp,x*=drawChrWidth,y*=chrHeight;var bg=col>>4&15,fg=15&col,rw=drawChrWidth,rh=chrHeight;scale>1?(rw*=scale,rh*=scale,x=x*scale+(cw-pw*scale)/2,y=y*scale+(ch-ph*scale)/2):(x+=(cw-pw)/2,y+=(ch-ph)/2),ctx.fillStyle=palette[bg],ctx.fillRect(x,y,rw,rh),bg!=fg&&ctx.drawImage(asciiFg[fg],(15&chr)*chrWidth,(chr>>4&15)*chrHeight,chrWidth,chrHeight,x,y,rw,rh)}},updRenderData=function(){if(null!=palette){var srcImg=null;if(charset_override_enabled){if(null==charset_override)return;srcImg=charset_override}else if(null==charset)return;if(asciiFg=[],null==srcImg){var charCanvas=document.createElement("canvas");charCanvas.width=128,charCanvas.height=224;for(var charCtx=charCanvas.getContext("2d"),charData=charCtx.createImageData(128,224),data=charData.data,dpos=0,ch=0;ch<256;ch++)for(var rx=(15&ch)*chrWidth,ry=(ch>>4)*chrHeight,cy=0;cy<chrHeight;cy++,dpos++)for(var co=128*(ry+cy)+rx,ctmp=charset[dpos],cx=0;cx<chrWidth;cx++,co++,ctmp<<=1){var cc=255*(ctmp>>7&1);data[4*co+0]=cc,data[4*co+1]=cc,data[4*co+2]=cc,data[4*co+3]=cc}charCtx.putImageData(charData,0,0),srcImg=charCanvas}asciiFg[15]=srcImg;for(var i=0;i<15;i++){var charCanvas=document.createElement("canvas");charCanvas.width=128,charCanvas.height=224;var charCtx=charCanvas.getContext("2d");charCtx.globalCompositeOperation="copy",charCtx.drawImage(srcImg,0,0),charCtx.globalCompositeOperation="source-in",charCtx.fillStyle=palette[i],charCtx.fillRect(0,0,128,224),asciiFg[i]=charCanvas}rdDirty=!1}};return{render:function(heap,mode,time){rdDirty&&updRenderData(),updVideoMode(mode);var pos=0;if(null!=asciiFg&&null!=palette)for(var y=0;y<25;y++)for(var x=0;x<scrWidth;x++,pos+=2)drawChar(x,y,heap[pos],heap[pos+1],time)},setCharset:function(width,height,heap){chrWidth=width,chrHeight=height,charset=heap,rdDirty=!0},setPalette:function(heap){palette=new Array;for(var i=0;i<16;i++){for(var s=(16777215&heap[i]).toString(16);s.length<6;)s="0"+s;palette[i]="#"+s}rdDirty=!0}}};
ZetaAudio={},function(){var audioCtx=void 0;document.addEventListener("mousedown",function(event){void 0==audioCtx&&(audioCtx=new(window.AudioContext||window.webkitAudioContext))}),document.addEventListener("keydown",function(event){void 0==audioCtx&&(audioCtx=new(window.AudioContext||window.webkitAudioContext))}),ZetaAudio.createOscillatorBased=function(){var lastCurrTime=0,lastTimeMs=0,timeSpeakerOn=0,audioGain=void 0,pc_speaker=void 0;return{on:function(freq){if(void 0!=audioCtx){var cTime=audioCtx.currentTime;cTime!=lastCurrTime&&(lastCurrTime=cTime,lastTimeMs=time_ms());var lastADelay=(time_ms()-lastTimeMs)/1e3;void 0==pc_speaker?(audioGain=audioCtx.createGain(),pc_speaker=audioCtx.createOscillator(),pc_speaker.type="square",pc_speaker.frequency.setValueAtTime(freq,audioCtx.currentTime+lastADelay),pc_speaker.connect(audioGain),audioGain.connect(audioCtx.destination),audioGain.gain.setValueAtTime(.2,audioCtx.currentTime),pc_speaker.start(0)):pc_speaker.frequency.setValueAtTime(freq,audioCtx.currentTime+lastADelay),timeSpeakerOn=time_ms()}},off:function(){if(void 0!=pc_speaker){var cTime=audioCtx.currentTime;cTime!=lastCurrTime&&(lastCurrTime=cTime,lastTimeMs=time_ms());var lastADelay=(time_ms()-lastTimeMs)/1e3;pc_speaker.frequency.setValueAtTime(0,audioCtx.currentTime+lastADelay)}}}},ZetaAudio.createBufferBased=function(emu,options){var pc_speaker=void 0,emu=emu,sampleRate=options&&options.sampleRate||48e3,bufferSize=options&&options.bufferSize||4096,init_speaker=function(){pc_speaker=audioCtx.createBufferSource();var buffer=audioCtx.createBuffer(1,2*bufferSize,sampleRate);pc_speaker.buffer=buffer,pc_speaker.connect(audioCtx.destination);var nativeBuffer=emu._malloc(bufferSize),nativeHeap=new Uint8Array(emu.HEAPU8.buffer,nativeBuffer,bufferSize);emu._audio_stream_init(time_ms(),sampleRate),emu._audio_stream_set_volume(Math.floor(.2*emu._audio_stream_get_max_volume()));var startedAt=0,startedAtMs=0,lastTime=0,write=function(offset){var out=buffer.getChannelData(0),sm=Math.min(time_ms(),1e3*(audioCtx.currentTime-startedAt)+startedAtMs);emu._audio_stream_generate_u8(sm,nativeBuffer,bufferSize);for(var i=0;i<bufferSize;i++)out[offset+i]=(nativeHeap[i]-127)/127},tick=function(){var ltPos=Math.floor(lastTime/(bufferSize/sampleRate)%2);ltPos!=Math.floor(audioCtx.currentTime/(bufferSize/sampleRate)%2)&&write(ltPos*bufferSize),lastTime=audioCtx.currentTime};pc_speaker.loop=!0,startedAt=audioCtx.currentTime,startedAtMs=time_ms(),pc_speaker.start(),lastTime=startedAt-.001,tick(),setInterval(tick,bufferSize/sampleRate*500)};return{on:function(freq){void 0!=audioCtx&&(void 0==pc_speaker&&init_speaker(),emu._audio_stream_append_on(time_ms(),freq))},off:function(){void 0!=pc_speaker&&emu._audio_stream_append_off(time_ms())}}}}();
ZetaKbdmap={ArrowUp:72,ArrowLeft:75,ArrowRight:77,ArrowDown:80,Home:71,End:79,Insert:82,Delete:83,PageUp:73,PageDown:81,Enter:28,Escape:1,Backspace:14,Tab:15,"-":12,_:12,"=":13,"+":13,"`":41,"~":41,"\\":43,"|":43,"*":55," ":57},function(){var addCharsInOrder=function(c,off){for(var i=0;i<c.length;i++)ZetaKbdmap[c.charAt(i)]=off+i};addCharsInOrder("1234567890",2),addCharsInOrder("QWERTYUIOP{}",16),addCharsInOrder("qwertyuiop[]",16),addCharsInOrder("asdfghjkl;'",30),addCharsInOrder('ASDFGHJKL:"',30),addCharsInOrder("zxcvbnm,./",44),addCharsInOrder("ZXCVBNM<>?",44);for(var i=1;i<=10;i++)ZetaKbdmap["F"+i]=58+i}();
function vfsg_time_ms(){return vfsg_time_ms_val}function vfsg_has_feature(id){return 1==id||2==id}function vfsg_open(fn,mode){"string"!=typeof fn&&(fn=emu.AsciiToString(fn)),fn=fn.toUpperCase();var data=vfs.get(fn),is_write=1==(3&mode);if(is_write){if(vfs.readonly())return-1;null!=data&&0==(65536&mode)||(data=new Uint8Array(0))}else if(null==data)return-1;console.log("opening "+fn);for(var i=1;i in handles;)i++;return handles[i]={fn:fn,pos:0,mode:mode,write_on_close:is_write,array:data},i}function vfsg_close(h){return h in handles?(handles[h].write_on_close&&vfs.set(handles[h].fn,handles[h].array),delete handles[h],0):-1}function vfsg_seek(h,pos,type){if(!(h in handles))return-1;var newpos=pos;return 1==type?newpos+=handles[h].pos:2==type&&(newpos+=handles[h].array.length),console.log("seek to "+newpos),newpos>handles[h].array.length?newpos=handles[h].array.length:newpos<0&&(newpos=0),handles[h].pos=newpos,0}function vfsg_read(h,ptr,amount){if(!(h in handles))return-1;h=handles[h];var maxlen=Math.min(amount,h.array.length-h.pos);console.log("reading "+maxlen+" bytes from "+h.pos+" to "+ptr);for(var heap=new Uint8Array(emu.HEAPU8.buffer,ptr,maxlen),pos=0;pos<maxlen;pos++)heap[pos]=h.array[h.pos+pos];return console.log("read "+maxlen+" bytes"),h.pos+=maxlen,maxlen}function vfsg_write(h,ptr,amount){if(!(h in handles))return-1;h=handles[h];var len=h.array.length,newlen=h.pos+amount;if(newlen>len){var newA=new Uint8Array(newlen);newA.set(h.array,0),h.array=newA,len=newlen}for(var heap=new Uint8Array(emu.HEAPU8.buffer,ptr,amount),pos=0;pos<amount;pos++)h.array[h.pos+pos]=heap[pos];return console.log("wrote "+amount+" bytes"),h.pos+=amount,amount}function vfsg_findfirst(ptr,mask,spec){spec=emu.AsciiToString(spec),ff_list=[];var l=vfs_list(spec);return null==l?-1:(ff_list=l,ff_pos=0,vfsg_findnext(ptr))}function vfsg_findnext(ptr){if(ff_pos>=ff_list.length)return-1;var finddata=new Uint8Array(emu.HEAPU8.buffer,ptr,256);finddata[21]=0,finddata[22]=0,finddata[23]=0,finddata[24]=0,finddata[25]=0;var fn=ff_list[ff_pos],size=vfs.get(fn).byteLength;finddata[26]=255&size,finddata[27]=size>>8&255,finddata[28]=size>>16&255,finddata[29]=size>>24&255;for(var i=0;i<fn.length;i++)finddata[30+i]=fn.charCodeAt(i);return finddata[30+fn.length]=0,ff_pos+=1,0}function zetag_update_charset(width,height,char_ptr){var data=new Uint8Array(emu.HEAPU8.buffer,char_ptr,256*height);render.setCharset(width,height,data)}function zetag_update_palette(palette_ptr){var data=new Uint32Array(emu.HEAPU32.buffer,palette_ptr,16);render.setPalette(data)}function speakerg_on(freq){if(!document.hasFocus())return void speakerg_off();void 0!=audio&&audio.on(freq)}function speakerg_off(){void 0!=audio&&audio.off()}function zeta_emu_create(options){zeta_options=options,canvas=options.render.canvas,canvas.contentEditable=!0,ctx=canvas.getContext("2d",{alpha:!1}),ctx.imageSmoothingEnabled=!1,attach_mouse_handler(canvas),vfs_files=options.files,vfs_arg=options.arg;for(var s in vfs_files)vfs_progress[s]=0,Array.isArray(vfs_files[s])?ZetaVfs.fromZip(vfs_files[s][0],vfs_files[s][1],function(p){vfs_progress[s]=p,draw_vfs_progress()},vfs_on_loaded):ZetaVfs.fromZip(vfs_files[s],null,function(p){vfs_progress[s]=p,draw_vfs_progress()},vfs_on_loaded);return{}}var canvas,ctx,audio,emu,render,zeta_options={},date_s=Date.now(),time_ms=function(){return Date.now()-date_s},vfs_progress={},vfs=null,handles={},vfsg_time_ms_val=0,ff_list=[],ff_pos=0,vfs_list=function(spec){if(spec=spec.toUpperCase(),spec.startsWith("*.")){var suffix=spec.substring(1),list=vfs.list(function(key){return key.endsWith(suffix)});return list.sort(function(a,b){var lenDiff=a.length-b.length;return 0!=lenDiff?lenDiff:a.localeCompare(b)}),list}return console.log("unknown findfirst spec: "+spec),null},queuedFrame=!1,zzt_frame=function(){poll_gamepads();var ptr=emu._zzt_get_ram(),heap=new Uint8Array(emu.HEAPU8.buffer,ptr+753664,4e3);render.render(heap,emu._zzt_video_mode(),vfsg_time_ms()),emu._zzt_mark_frame(),queuedFrame=!1},last_timer_time=0,timer_dur=1e3/18.2,opcodes=1e3,zzt_tick=function(){vfsg_time_ms_val=time_ms();for(var tms=vfsg_time_ms();tms-last_timer_time>=timer_dur;)last_timer_time+=timer_dur,emu._zzt_mark_timer();var rcode=emu._zzt_execute(opcodes),duration=time_ms()-tms;if(rcode){1==rcode&&(duration<3?opcodes=20*opcodes/19:duration>6&&(opcodes=19*opcodes/20)),queuedFrame||(queuedFrame=!0,window.requestAnimationFrame(zzt_frame));var time_to_timer=timer_dur-(tms+duration-last_timer_time);3!=rcode||time_to_timer<=1?window.postMessage("zzt_tick","*"):setTimeout(zzt_tick,time_to_timer)}};window.addEventListener("message",function(event){"zzt_tick"==event.data&&(event.stopPropagation(),zzt_tick())},!0);var vfs_arg=null,vfs_done=function(){if(vfs=ZetaVfs.fromProviders(vfs_providers),null==vfs_arg||""==vfs_arg)if(vfs.contains("ZZT.EXE")&&!vfs.contains("TOWN.ZZT")){var zlist=vfs_list("*.ZZT");zlist.length>0&&(vfs_arg=zlist[0])}else if(vfs.contains("SUPERZ.EXE")&&!vfs.contains("MONSTER.SZT")){var zlist=vfs_list("*.SZT");zlist.length>0&&(vfs_arg=zlist[0])}zeta_options.render.hasOwnProperty("blink")||(zeta_options.render.blink=!vfs.contains("BLINKX.COM")),render=ZetaRender.toCanvas(zeta_options.render.canvas,zeta_options.render),vfs_arg=(vfs_arg||"").toUpperCase(),draw_progress(1),ZetaNative().then(function(c){emu=c,audio=ZetaAudio.createOscillatorBased();for(var buffer=emu._malloc(vfs_arg.length+1),heap=new Uint8Array(emu.HEAPU8.buffer,buffer,vfs_arg.length+1),i=0;i<vfs_arg.length;i++)heap[i]=vfs_arg.charCodeAt(i);heap[vfs_arg.length]=0,emu._zzt_init();var handle=vfsg_open("zzt.exe",0);if(handle<0&&(handle=vfsg_open("superz.exe",0)),handle<0)throw"Could not find ZZT executable!";emu._zzt_load_binary(handle,buffer),vfsg_close(handle),emu._zzt_set_timer_offset(Date.now()%864e5),last_timer_time=time_ms(),zzt_tick()})};document.addEventListener("keydown",function(event){if(event.target!=canvas)return!1;var ret=!1;"Shift"==event.key?emu._zzt_kmod_set(1):"Control"==event.key?emu._zzt_kmod_set(4):"Alt"==event.key||"AltGraph"==event.key?emu._zzt_kmod_set(8):ret=!1;var chr=1==event.key.length?event.key.charCodeAt(0):event.keyCode<32?event.keyCode:0,key=ZetaKbdmap[event.key]||0;return key>=70&&key<=83&&(chr=0),(chr>0||key>0)&&(emu._zzt_key(chr,key),ret=!0),ret&&event.preventDefault(),!1},!1),document.addEventListener("keyup",function(event){if(event.target!=canvas)return!1;var ret=!0;"Shift"==event.key?emu._zzt_kmod_clear(1):"Control"==event.key?emu._zzt_kmod_clear(4):"Alt"==event.key||"AltGraph"==event.key?emu._zzt_kmod_clear(8):ret=!1;var key=ZetaKbdmap[event.key]||0;return key>0&&(emu._zzt_keyup(key),ret=!0),ret&&event.preventDefault(),!1},!1);var vfs_providers=[],vfs_files=[],vfs_files_pos=0,draw_progress=function(p){var cx=(canvas.width-640)/2,cy=(canvas.height-350)/2;ctx.fillStyle="#ff0000",ctx.fillRect(cx+28,cy+224,292*p*2,20)},get_vfs_prog_total=function(){var i=0;for(var k in vfs_progress)i+=vfs_progress[k];return i},draw_vfs_progress=function(){draw_progress(get_vfs_prog_total()/vfs_files.length)},vfs_on_loaded=function(p){vfs_providers.push(p),draw_vfs_progress(),(vfs_files_pos+=1)==vfs_files.length&&vfs_done()},poll_gamepads=function(){for(var gamepads=navigator.getGamepads(),i=0;i<gamepads.length;i++){var gamepad=gamepads[i];if(null!=gamepad&&gamepad.axes.length>=2&&gamepad.buttons.length>=1){var ax0=gamepad.axes[0],ax1=gamepad.axes[1];ax0=Math.round(127*ax0),ax1=Math.round(127*ax1),emu._zzt_joy_axis(0,ax0),emu._zzt_joy_axis(1,ax1),emu._zzt_joy_clear(0);for(var j=0;j<gamepad.buttons.length;j++)if(gamepad.buttons[j].pressed){emu._zzt_joy_set(0);break}}}},mouseSensitivity=4,attach_mouse_handler=function(o){o.addEventListener("mousemove",function(e){if(void 0!=emu){var mx=e.movementX*mouseSensitivity,my=e.movementY*mouseSensitivity;emu._zzt_mouse_axis(0,mx),emu._zzt_mouse_axis(1,my)}}),o.addEventListener("mousedown",function(e){o.requestPointerLock(),void 0!=emu&&emu._zzt_mouse_set(e.button)}),o.addEventListener("mouseup",function(e){void 0!=emu&&emu._zzt_mouse_clear(e.button)})};
